                                                                                                                                                                                                                                                               
/*
+------------------------------------+
| M_M- Nina System                      |
+------------------------------------+
 
*/


// variables declared here are GLOBAL in scope

#property copyright "M_M-- Nina System"
#property link      "http://www.forex-tsd.com/showthread.php?t=523"

// user input
extern double Lots=0.1;
extern int    Slippage=2;
extern int    NumberOfOrders=9;
extern bool   UseOpts=true;





//StepMA
extern int confirm_StepMA_Bars=3;
extern int EMA_period=50;

// these two lines are over-ridden my UseOpts
extern int    ProfitMade=60;   // how much money do you want ( see init() section )
extern int    StopLoss=35;    // optimized per pair (see init() section)
extern bool   ProfitTrailing = True;  
extern int    TrailingStop   = 30;     
extern int    TrailingStep   = 2;     
extern bool   UseSound       = True;  
extern string NameFileSound  = "expert.wav";  


//Time_Limited
extern int   OpenHour     = 7;      // GMT
extern int   OpenMinute   = 00;      // 
extern int   CloseHour     = 17;      //GMT 
extern int   CloseMinute   = 0;      // 



// only used in case computer or internet fails
int      TakeProfit=60;

// naming and numbering
int      MagicNumber  = 200510301113;
string   TradeComment = "Nina_System";

// Bar handling
datetime bartime=0;
int      bartick=0;

// one trade per cross control
bool TradeAllowed=false;


//+-------------+
//| Custom init |
//|-------------+
// Called ONCE when EA is added to chart or recompiled
int init()
  {
   Print ("Init happened ",CurTime());



   // one month optimizations to MT data feed
   
   if(UseOpts)
     {

      if (Symbol()=="GBPUSD")  {ProfitMade= 60; StopLoss=35;}

     }//UseOpts
     
   Print(Symbol()," is using ProfitMade=",ProfitMade," and StopLoss=",StopLoss);
   Comment(" ");
  }


//+----------------+
//| Custom DE-init |
//+----------------+
// Called ONCE when EA is removed from chart
int deinit()
  {
   Print           ("DE-Init happened ",CurTime());
   Comment(" ");
  }


//+-----------+
//| Main      |
//+-----------+
// Called EACH TICK and each Bar[]

int start()
  {

   double p=Point();
   int      i=0;
   int      j=0;
   int      cnt=0;
   int      gle=0;
   int      OrdersPerSymbol=0;
   
   // stoploss and takeprofit calcs
   double SL=0;
   double TP=0;

   double EMA50_Shift[];
   double Stepma_Shift0_Yellow=0;
   double Stepma_Shift0_Blue=0;
   double Stepma_Shift1_Yellow=0;
   double Stepma_Shift1_Blue=0;
   double Stepma_Shift2_Yellow=0;
   double Stepma_Shift2_Blue=0;
   double Stepma_Shift3_Yellow=0;
   double Stepma_Shift3_Blue=0;
   double Stepma_Shift4_Yellow=0;
   double Stepma_Shift4_Blue=0;
   double Stepma_Shift5_Yellow=0;
   double Stepma_Shift5_Blue=0;
 
       //StepMA_Stoch_v1 For Cross Identity TimeFrame M30
       Stepma_Shift0_Yellow=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,0,0);// yellow
       Stepma_Shift0_Blue=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,1,0);// Blue
       Stepma_Shift1_Yellow=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,0,1);// yellow
       Stepma_Shift1_Blue=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,1,1);// Blue
       Stepma_Shift2_Yellow=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,0,2);// yellow
       Stepma_Shift2_Blue=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,1,2);// Blue
       Stepma_Shift3_Yellow=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,0,3);// yellow
       Stepma_Shift3_Blue=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,1,3);// Blue
       Stepma_Shift4_Yellow=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,0,4);// yellow
       Stepma_Shift4_Blue=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,1,4);// Blue
       Stepma_Shift5_Yellow=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,0,5);// yellow
       Stepma_Shift5_Blue=iCustom(Symbol(),30,"StepMA_Stoch_v1",10,1.0,0,1,5);// Blue              

   // PLEASE NOTE
   // There is no error checking here for AccountFreeMargin
   // That's because ProfitMade is in a loop at the bottom of this code.
   // If you exit on no margin, you can NEVER collect profit from remaing 
   // open trades because the code that would collect it can never execute.
   // Besides, the server won't let you trade anyway, so it was only a courtesy.
   
   // bar counting
   if(bartime!=Time[0]) {bartime=Time[0]; bartick++; TradeAllowed=true;}
   

/* only for remind
//Main 
// Getting Signals 
   //for(i=3; i>=0; i--)
   //  {
      //EMA50_Shift1=iMA(Symbol(),30,EMA_period,0,MODE_EMA,PRICE_MEDIAN,1);
      EMA50_Shift[i]=iMA(Symbol(),30,EMA_period,0,MODE_EMA,PRICE_MEDIAN,i);
      //Cross EMA50 By Price in 1 to 3 Bar
      //Long check start
      if  ((Low[i+1]<EMA50_Shift[i+1])&&(Close[i+1]>EMA50_Shift[i+1])&&(Open[i]>EMA50_Shift[i])//cross EMA50 in Bar 1 
        //|| (Low[i+2]<EMA50_Shift[i+2])&&(Close[i+2]>EMA50_Shift[i+2])&&(Open[i]>EMA50_Shift[i])//cross EMA50 in Bar 2 
        //|| (Low[i+3]<EMA50_Shift[i+3])&&(Close[i+3]>EMA50_Shift[i+3])&&(Open[i]>EMA50_Shift[i])//cross EMA50 in Bar 3 
        )       
       {
        //Cross Identity TimeFrame M30 and Validity Cross EMA50 By Price   
       if (((Stepma_Shift2_Yellow + 0.02)<Stepma_Shift2_Blue)&&(Stepma_Shift1_Yellow>(Stepma_Shift1_Blue + 0.02)))//StepMA cross
       {
       
       
       
       }//if Stepma_Shift2
    }//if Cross EMA50 By Price

*/

   



//Preparing to Order
   OrdersPerSymbol=0;
   for(cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
        {
         OrdersPerSymbol++;
        }
     }

   if((OrdersPerSymbol < NumberOfOrders) && TradeAllowed)
     {
     if (OrdersTotal()<1)
       { 
      ////Hour Entry & Exit 
     if ((Hour()>=OpenHour) && (Hour()<CloseHour))
      {
      //ENTRY LONG (buy, Ask) 
      
      //Long check start     
       if  (iOpen(Symbol(),30,1)<EMA50_Shift[i+1] 
           && iClose(Symbol(),30,1)>EMA50_Shift[i+1]
           && Stepma_Shift1_Yellow>(Stepma_Shift1_Blue + 0.02)
           && Stepma_Shift2_Blue>(Stepma_Shift2_Yellow + 0.02)
           && iOpen(Symbol(),30,0)>EMA50_Shift[i]
          )
       {
		   //Ask(buy, long)
         SL=Ask-(StopLoss*p);
         TP=Ask+(TakeProfit*p);
         OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,TradeComment,MagicNumber,White);
         gle=GetLastError();
         if(gle==0)
           {
            Print           ("BUY  Ask=",Ask," bartick=",bartick);
            bartick=0;
            TradeAllowed=false;
           }
            else 
           {
            Print           ("BUY  -----ERROR----- Ask=",Ask,"  gle=",gle," bartick=",bartick);
           }
         return(0);
         
         }


/*
      //Long PullBack
       if ((Stepma_Shift0_Yellow>(Stepma_Shift0_Blue + 0.02)) 
        && (Stepma_Shift1_Yellow>(Stepma_Shift1_Blue + 0.02))//StepMA cross
        )
       {
       //Check 4 Previous Bar
        if ((Close[i+2]<EMA50_Shift[i+2])
           &&(High[i+2]>EMA50_Shift[i+2])
           &&(Close[i+1]>EMA50_Shift[i+1])
           &&(Low[i+1]>EMA50_Shift[i+1])
           &&(Open[i]>EMA50_Shift[i])
           
           )             
        {
		   //Ask(buy, long)
         SL=Ask-(StopLoss*p);
         TP=Ask+(TakeProfit*p);
         OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,SL,TP,TradeComment,MagicNumber,White);
         gle=GetLastError();
         if(gle==0)
           {
            Print           ("BUY  Ask=",Ask," bartick=",bartick);
            bartick=0;
            TradeAllowed=false;
           }
            else 
           {
            Print           ("BUY  -----ERROR----- Ask=",Ask,"  gle=",gle," bartick=",bartick);
           }
         return(0);
       }//if Stepma_Shift2
    }//if Cross 
*/



      
      
       
      //ENTRY SHORT (sell, Bid)
      //Short check start
       if  (iOpen(Symbol(),30,1)>EMA50_Shift[i+1] 
           && iClose(Symbol(),30,1)<EMA50_Shift[i+1]
           && Stepma_Shift1_Blue>(Stepma_Shift1_Yellow + 0.02)
           && Stepma_Shift2_Yellow>(Stepma_Shift2_Blue + 0.02)           
           && iOpen(Symbol(),30,0)<EMA50_Shift[i]
          )
       {
       
         SL=Bid+(StopLoss*p);
         TP=Bid-(TakeProfit*p);
         OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,TradeComment,MagicNumber,Red);
         gle=GetLastError();
         if(gle==0)
           {
            Print           ("SELL Bid=",Bid," bartick=",bartick); 
            bartick=0;
            TradeAllowed=false;
           }
            else 
           {
            Print           ("SELL -----ERROR----- Bid=",Bid," gle=",gle," bartick=",bartick); 
           }
         return(0);
       
       }


/*
      //Short PullBack  
       if (((Stepma_Shift0_Yellow + 0.02)<Stepma_Shift0_Blue )
        && ((Stepma_Shift1_Yellow + 0.02)<Stepma_Shift1_Blue )//StepMA cross
        )
       {
       //Check 4 Previous Bar
        if ((Close[i+2]>EMA50_Shift[i+2])
           &&(Low[i+2]<EMA50_Shift[i+2])
           &&(Close[i+1]<EMA50_Shift[i+1])
           &&(High[i+1]<EMA50_Shift[i+1])
           &&(Open[i]<EMA50_Shift[i])
           
           )             
        {
         SL=Bid+(StopLoss*p);
         TP=Bid-(TakeProfit*p);
         OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,SL,TP,TradeComment,MagicNumber,Red);
         gle=GetLastError();
         if(gle==0)
           {
            Print           ("SELL Bid=",Bid," bartick=",bartick); 
            bartick=0;
            TradeAllowed=false;
           }
            else 
           {
            Print           ("SELL -----ERROR----- Bid=",Bid," gle=",gle," bartick=",bartick); 
           }
         return(0);
        }//if Stepma_Shift
       }//if Cross 
*/



       
       
      }//Hour Entry & Exit
    } //if OrdersTotal
   }//(OrdersPerSymbol < NumberOfOrders) && TradeAllowed)





  for (int k=0; k<OrdersTotal(); k++) {
    if (OrderSelect(k, SELECT_BY_POS, MODE_TRADES)) {
      TrailingPositions();
    }
  }

 } // start()

//+------------------------------------------------------------------+
//| TrailingPositions                                                |
//+------------------------------------------------------------------+
void TrailingPositions() {
  double pBid, pAsk, pp;

  pp = MarketInfo(OrderSymbol(), MODE_POINT);
  if (OrderType()==OP_BUY) {
    pBid = MarketInfo(OrderSymbol(), MODE_BID);
     //The First TrailingStop_10
    //if ((pBid>=(OrderOpenPrice()+10*pp)) && (pBid<=(OrderOpenPrice()+12*pp)))
    //{
   //   OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);
   // }
     //Trailing_Profit_near_5Point
    if ((OrderTakeProfit()-pBid)<=5*pp) 
    {
      OrderModify(OrderTicket(),OrderOpenPrice(),(pBid-10*pp),(pBid+10*pp),0,CLR_NONE);
    }    
    
    if (!ProfitTrailing || (pBid-OrderOpenPrice())>TrailingStop*pp) {
      if (OrderStopLoss()<pBid-(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) {
        ModifyStopLoss(pBid-TrailingStop*pp);
        return;
      }
    }
  }
  if (OrderType()==OP_SELL) {
    pAsk = MarketInfo(OrderSymbol(), MODE_ASK);
     //The First TrailingStop_10
    //if ((pAsk<=(OrderOpenPrice()-10*pp)) && (pAsk>=(OrderOpenPrice()-12*pp)))
    //{
    // OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice(),OrderTakeProfit(),0,CLR_NONE);
   // }
     //Trailing_Profit_near_5Point
    if ((pAsk-OrderTakeProfit())<=5*pp) 
    {
      OrderModify(OrderTicket(),OrderOpenPrice(),(pAsk+10*pp),(pAsk-10*pp),0,CLR_NONE);
    }     
    
    if (!ProfitTrailing || OrderOpenPrice()-pAsk>TrailingStop*pp) {
      if (OrderStopLoss()>pAsk+(TrailingStop+TrailingStep-1)*pp || OrderStopLoss()==0) {
        ModifyStopLoss(pAsk+TrailingStop*pp);
        return;
      }
    }
  }
}//void

//+------------------------------------------------------------------+
//| ModifyStopLoss                                                   |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
void ModifyStopLoss(double ldStopLoss) {
  bool fm;

  fm=OrderModify(OrderTicket(),OrderOpenPrice(),ldStopLoss,OrderTakeProfit(),0,CLR_NONE);
  if (fm && UseSound) PlaySound(NameFileSound);
}
//+------------------------------------------------------------------+


	



/*

   // CLOSE order if profit target made
   // CLOSE order if invert Signal 
   for(cnt=0;cnt<OrdersTotal();cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber )
        {
         if(OrderType()==OP_BUY)
           {
            // did we make our desired BUY profit?
            //if(Bid-OrderOpenPrice() > ProfitMade*p  )
            
          
      if (MAFast_SMOOTHED_M15_Shift0<MASlow_SMOOTHED_M15_Shift0)
		  {
		 if((MAFast_SMOOTHED_M5_Shift0<MASlow_SMOOTHED_M5_Shift0) && (MAFast_SMOOTHED_M1_Shift0<MASlow_SMOOTHED_M1_Shift0) && (MAFast_SMOOTHED_M5_Shift1<MASlow_SMOOTHED_M5_Shift1) && (MAFast_SMOOTHED_M1_Shift1<MASlow_SMOOTHED_M1_Shift1)) 
		  {
		
               OrderClose(OrderTicket(),Lots,Bid,Slippage,White);
               gle=GetLastError();
               if(gle==0)
                 {
                  Print           ("BUYCLOSE Bid=",Bid," bartick=",bartick); 
                  bartick=0;
                 }
                  else 
                 {
                  Print           ("BUY  CLOSE -----ERROR----- Bid=",Bid," gle=",gle," bartick=",bartick);
                 }
               return(0);
              
              }//if
             }//if
           
           } // if BUY

         if(OrderType()==OP_SELL)
           {
            // did we make our desired SELL profit?
            //if(OrderOpenPrice()-Ask > (ProfitMade*p)   )
            
           
      if (MAFast_SMOOTHED_M15_Shift0>MASlow_SMOOTHED_M15_Shift0)
		  {
		 if((MAFast_SMOOTHED_M5_Shift0>MASlow_SMOOTHED_M5_Shift0) && (MAFast_SMOOTHED_M1_Shift0>MASlow_SMOOTHED_M1_Shift0) && (MAFast_SMOOTHED_M5_Shift1>MASlow_SMOOTHED_M5_Shift1) && (MAFast_SMOOTHED_M1_Shift1>MASlow_SMOOTHED_M1_Shift1)) 
		  {
		   
               OrderClose(OrderTicket(),Lots,Ask,Slippage,Red);
               if(gle==0)
                 {
                  Print           ("SELLCLOSE Ask=",Ask," bartick=",bartick);
                  bartick=0;
                 }
                  else 
                 {
                  Print           ("SELL CLOSE -----ERROR----- Ask=",Ask," gle=",gle," bartick=",bartick);
                 }
               return(0);
             
              }//if
             }//if
            
           } //if SELL
           
        } // if(OrderSymbol)
        
     } // for
*/